$NICName = '{{ net_adapter['name'] }}'
$NIC = Get-NetAdapter | Where-Object {$_.Name -eq $NICName}
$Ansible.Failed = $false

try {
    if ($NIC) {
        $CurrentSetting = Get-DnsClient -InterfaceIndex $NIC.ifIndex

        if ($CurrentSetting.{{ net_adapter['property'] }} -ne {{  net_adapter['value'] }} ) {
            Set-DnsClient -InterfaceIndex $NIC.ifIndex -{{ net_adapter['property'] }} {{  net_adapter['value'] }}
            $Ansible.Changed = $true
        } else {
            $Ansible.Changed = $false
        }
    } else {
        $Ansible.Changed = $false
        $Ansible.Failed = $true
        Write-Error "Adapter was not found"
    }
}
catch {
    $Ansible.Failed = $true
    Write-Error "An error occurred: $_"
}
